" Vim syntax file
" Language:	mn8
" Maintainer:	Remus Pereni <remus@nolimits.ro>
" Last Change: $Date: 2002/03/07 10:54:20 $	
" Revision: $Revision: 1.3 $

" This syntax file not a complete implementation yet.  Send suggestions to the
" maintainer.

" Quit when a syntax file was already loaded
if exists("b:current_syntax")
  finish
endif

" A bunch of useful mn8 keywords
syn keyword mn8Statement	THIS This this	
syn keyword mn8Statement	TYPEOF TypeOf Typeof typeof	
syn keyword mn8Statement	DEFINE Define define	
syn keyword mn8Statement	LABEL Label label	
syn keyword mn8Statement	EXTENDS Extends extends	
syn keyword mn8Statement	TO To to BY By by	
syn keyword mn8Statement	OPTIONS Options Options 	
syn keyword mn8Statement	FROM From from	
syn keyword mn8Statement	FILTER Filter filter	
syn keyword mn8Statement	LIMIT Limit Limit	
syn keyword mn8Statement	REQUESTS Requests requests	
syn keyword mn8Statement	DEPTH Depth depth	
syn keyword mn8Statement	ASCENDING Ascending ascending	
syn keyword mn8Statement	DESCENDING Descending descending	
syn keyword mn8Statement	RETURN Return return	
syn keyword mn8Statement	TIMEOUT TimeOut Timeout timeout	
syn keyword mn8Statement	IF If if ELIF ElIf Elif elif ELSE Else else THEN Then then
syn keyword mn8Statement	SWITCH Switch switch CASE Case case
syn keyword mn8Statement	WHILE While while
syn keyword mn8Statement	DO Do do
syn keyword mn8Statement	EACH Eeach each
syn keyword mn8Statement	WHERE Where where
syn keyword mn8Statement	BREAK Break break
syn keyword mn8Statement	BY By BY
syn keyword mn8Statement	FIND Find find
syn keyword mn8Statement	IN In in
syn keyword mn8Statement	FIRST First first
syn keyword mn8Statement	LAST Last last
syn keyword mn8Statement	INCLUDE Include include
syn keyword mn8Statement	SUPER Super super
syn keyword mn8Statement	PRINT Print print
syn keyword mn8Statement	true TRUE True FALSE False false

syn keyword mn8Function		AND And and
syn keyword mn8Function		OR Or or
syn keyword mn8Function		NOT Not not
syn keyword mn8Todo contained	TODO

syn keyword mn8Modifier		STATIC Static static

syn match   mn8MathsOperator "[<>+\*^/\\=-]"
syn match   mn8ConfigFunction  "\<[A-Z_][A-Z0-9_]*\>"
syn match   mn8ConfigDelimiter "[()\[\];,]"
  
"integer number, or floating point number without a dot.
syn match  mn8Number		"\<\d\+\>"
"floating point number, with dot
syn match  mn8Number		"\<\d\+\.\d*\>"
"floating point number, starting with a dot
syn match  mn8Number		"\.\d\+\>"

" String and Character contstants
syn match   mn8Special contained "\\\d\d\d\|\\."
syn region  mn8String		  start=+"+  skip=+\\\\\|\\"+  end=+"+  contains=mn8Special

syn region  mn8Comment	start="#" end="$" contains=mn8Todo
syn region  mn8Comment	start="^[ \t]*'" end="$" contains=mn8Todo
syn region  mn8LineNumber	start="^\d" end="\s"
syn match   mn8TypeSpecifier  "[a-zA-Z0-9][\$%&!#]"ms=s+1
" Used with OPEN statement
syn match   mn8Filenumber  "#\d\+"
syn match   mn8MathsOperator   "-\|=\|[+\*^/\\]\|AND\|OR|.|/"
syn match   mn8Attribute   "@[a-zA-Z_-]\+[0-9a-zA-Z]*"
syn match   mn8Variable    "$[a-zA-Z_-]\+[0-9a-zA-Z]*"


" The default highlighting.
hi def link mn8Label		Label
hi def link mn8Conditional	Conditional
hi def link mn8Repeat		Repeat
hi def link mn8LineNumber	Comment
hi def link mn8Number		Number
hi def link mn8Error		Error
hi def link mn8Statement	Statement
hi def link mn8String		String
hi def link mn8Comment		Comment
hi def link mn8Special		Special
hi def link mn8Todo		Todo
hi def link mn8Function		Identifier
hi def link mn8TypeSpecifier 	Type
hi def link mn8ConfigFunction 	Function
hi def link mn8ConfigDelimiter 	Delimiter
hi def link mn8Modifier 	Type
"hi def link mn8Attribute 	Type
"hi def link mn8Variable 	Identifier

let b:current_syntax = "mn8"

"vim: ts=4
