<?xml version="1.0" encoding="utf-8"?>

<xsl:stylesheet   
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"  
  version="1.0">

<xsl:output encoding="iso-8859-1"  
  doctype-public='-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd'  
  method="html"/>  

<xsl:template match="scriptref">    
<html>
  <head>
    <title><xsl:value-of select="@name"/></title>
    <link href="../res/mref.css" rel="StyleSheet" TITLE="Default" MEDIA="screen"/>
  </head>      
  <body bgcolor="#FFFFFF">        
  <table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="#eceef9">
    <tr>
      <td bgcolor="#eceef9" align="right">
        <a href="../reference/index.html">mn8 Language Reference</a>
        <xsl:text disable-output-escaping="yes">&amp;nbsp;|&amp;nbsp;</xsl:text>
        <a href="../index_all.html">Index</a>
        <xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;</xsl:text>
      </td>
    </tr>
    <tr>
      <td bgcolor="#eceef9"><h2><a name="top">  <xsl:value-of select="@name"/></a></h2>
    </td>
    </tr>
    <tr>
      <td>
        <table width="95%" cellspacing="0" cellpadding="0" border="0" align="center">
          <tr>
            <td valign="middle" width="50%">
              <xsl:text>SUMMARY:</xsl:text><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
                <xsl:choose>
                  <xsl:when test="//attribute">
                    <a href="#AttributeList"><img src="../images/A.gif" alt="ATTRIBUTES SUMMARY" border="0"/></a><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>                    
                  </xsl:when>
                  <xsl:otherwise>
                    <img src="../images/A_d.gif" alt="NO ATTRIBUTES" border="0"/><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>                    
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:choose>
                  <xsl:when test="//element">
                    <a href="#ElementList"><img src="../images/E.gif" alt="ELEMENTS SUMMARY" border="0"/></a><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>                    
                  </xsl:when>
                  <xsl:otherwise>
                    <img src="../images/E_d.gif" alt="NO ELEMENTS" border="0"/><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>                    
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:choose>
                  <xsl:when test="//constructor">
                    <a href="#ConstructorList"><img src="../images/C.gif" alt="CONSTRUCTORS SUMMARY" border="0"/></a><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>                    
                  </xsl:when>
                  <xsl:otherwise>
                    <img src="../images/C_d.gif" alt="NO CONSTRUCTORS" border="0"/><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>                    
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:choose>
                  <xsl:when test="//operator">                    
                    <a href="#OperatorList"><img src="../images/O.gif" alt="OPERATORS SUMMARY" border="0"/></a><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>                  
                  </xsl:when>
                  <xsl:otherwise>
                    <img src="../images/O_d.gif" alt="NO OPERATORS" border="0"/><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>                    
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:choose>
                  <xsl:when test="//method">
                    <a href="#MethodList"><img src="../images/M.gif" alt="METHODS SUMMARY" border="0"/></a>
                  </xsl:when>
                  <xsl:otherwise>
                    <img src="../images/M_d.gif" alt="NO METHODS" border="0"/>
                  </xsl:otherwise>
                </xsl:choose>
            </td>
            <td width="50%" valign="middle">
              <xsl:text>DETAIL:</xsl:text><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
                <xsl:choose>
                  <xsl:when test="//attribute">
                    <a href="#AttributeInfo"><img src="../images/A.gif" alt="ATTRIBUTE DETAILS" border="0"/></a><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>                    
                  </xsl:when>
                  <xsl:otherwise>
                    <img src="../images/A_d.gif" alt="NO ATTRIBUTES" border="0"/><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>                    
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:choose>
                  <xsl:when test="//element">
                    <a href="#ElementInfo"><img src="../images/E.gif" alt="ELEMENT DETAILS" border="0"/></a><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>                    
                  </xsl:when>
                  <xsl:otherwise>
                    <img src="../images/E_d.gif" alt="NO ELEMENTS" border="0"/><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>                    
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:choose>
                  <xsl:when test="//constructor">
                    <a href="#ConstructorInfo"><img src="../images/C.gif" alt="CONSTRUCTOR DETAILS" border="0"/></a><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>                    
                  </xsl:when>
                  <xsl:otherwise>
                    <img src="../images/C_d.gif" alt="NO CONSTRUCTORS" border="0"/><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>                    
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:choose>
                  <xsl:when test="//operator">                    
                    <a href="#OperatorInfo"><img src="../images/O.gif" alt="OPERATOR DETAILS" border="0"/></a><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>                  
                  </xsl:when>
                  <xsl:otherwise>
                    <img src="../images/O_d.gif" alt="NO OPERATORS" border="0"/><xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>                    
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:choose>
                  <xsl:when test="//method">
                    <a href="#MethodInfo"><img src="../images/M.gif" alt="METHOD DETAILS" border="0"/></a>
                  </xsl:when>
                  <xsl:otherwise>
                    <img src="../images/M_d.gif" alt="NO METHODS" border="0"/>
                  </xsl:otherwise>
                </xsl:choose>
            </td>            
          </tr>
        </table>
        </td>
    </tr>
    <tr>
      <td><img src="../images/bottom.gif" width="100%" height="10" alt=""/></td>
    </tr>
  </table>
  <h3><a name="Description">Description</a></h3>
  <xsl:choose>  
    <xsl:when test="/scriptref/description">
        <xsl:apply-templates select="/scriptref/description"/>
    </xsl:when>
    <xsl:otherwise>
        <xsl:apply-templates select="/scriptref/meta/info"/>
    </xsl:otherwise>
  </xsl:choose>
  
  <h3><a name="Usage">Usage</a></h3>
  <xsl:apply-templates select="/scriptref/usage" />
  
  <xsl:apply-templates select="/scriptref/meta" />
    
  <xsl:apply-templates select="/scriptref/attributes" />
  <xsl:apply-templates select="/scriptref/inheritedAttributes" />
  
  <xsl:apply-templates select="/scriptref/elementes" />
  <xsl:apply-templates select="/scriptref/inheritedElementes" />
  
  <xsl:apply-templates select="/scriptref/constructors" />
  <xsl:apply-templates select="/scriptref/operators" />
  
  <xsl:apply-templates select="/scriptref/methods" />
  <xsl:apply-templates select="/scriptref/inheritedMethods" />
  
  <xsl:call-template name="AttrInfo"/>
  <xsl:call-template name="ElemInfo"/>
  <xsl:call-template name="ConstructorInfo"/>
  <xsl:call-template name="OperatorInfo"/>
  <xsl:call-template name="MethodInfo"/>
</body>    
</html>  
</xsl:template>  

<xsl:template match="meta">
    <table width="95%" border="0">
        <xsl:if test="../@version">
            <tr>
            <td align="right" width="15%">
                <font color="#777777">Version: </font> 
            </td>
            <td width="85%">
                <xsl:value-of select="../@version"/>
            </td>
            </tr>
        </xsl:if>    
        <xsl:apply-templates select="authors"/>  
        <xsl:apply-templates select="location"/>
        
        <xsl:if test="/scriptref/inherits">
        <tr>
            <td align="right" width="15%" valign="top">
                <font color="#777777">Inherits: </font> 
            </td>
            <td width="85%">
                <xsl:apply-templates select="/scriptref/inherits"/>
            </td>
        </tr>
        </xsl:if>
        
        <xsl:if test="/scriptref/inheritedBy">
        <tr>
            <td align="right" width="15%" valign="top">
                <font color="#777777">Inherited by: </font> 
            </td>
            <td width="85%">
                <xsl:apply-templates select="/scriptref/inheritedBy"/>
            </td>
        </tr>        
        </xsl:if>
        
    </table>
</xsl:template>  

<xsl:template match="info">    
    <xsl:apply-templates/>
</xsl:template>  


<xsl:template match="authors">    
    <xsl:if test="person">
        <tr>
        <td align="right" width="15%" valign="top">
            <font color="#777777">Authors:</font>
        </td>
        <td width="85%">
            <xsl:apply-templates select="person"/>
        </td>
        </tr>
</xsl:if>  
</xsl:template> 

<xsl:template match="location">    
    <xsl:if test="@url">      
        <tr>
        <td align="right" width="15%" valign="top">
            <font color="#777777">Location:</font>
        </td>
        <td width="85%">
            <a href="{@url}"><xsl:value-of select="@url"/></a>
        </td>
        </tr>        
    </xsl:if>  
</xsl:template>  

<xsl:template match="person">        
    <xsl:choose>             
        <xsl:when test="@email">        
            <a href="mailto:{@email}"><xsl:value-of select="@name"/></a>      
        </xsl:when>      
        <xsl:otherwise>        
            <xsl:value-of select="@name"/>     
        </xsl:otherwise>      
    </xsl:choose>      
    <xsl:if test="@homepage">        
        <xsl:text> (</xsl:text>        
            <a href="{@homepage}"><xsl:value-of select="@homepage"/></a>        
        <xsl:text>)</xsl:text>      
    </xsl:if>
    <br/>           
</xsl:template>  

<xsl:template match="usage">        
    <xsl:apply-templates/>     
</xsl:template>  


<xsl:template match="inherits">
    <xsl:apply-templates select="concept" mode="inheritedConcepts"/>  
</xsl:template>

<xsl:template match="concept" mode="inheritedConcepts">
  <a href="{@docName}"><xsl:value-of select="@name"/></a>
  <xsl:if test="not(position() = last())">
    <xsl:text>, </xsl:text>
  </xsl:if>
</xsl:template>


<xsl:template match="inheritedBy">  
    <xsl:apply-templates select="concept" mode="inheritedConcepts"/>
</xsl:template>

<xsl:template match="attributes"> 
<h3><a name="AttributeList">Attribute List</a></h3>
<table width="95%" cellspacing="1" cellpadding="3" align="center" border="0" bgcolor="#dddddd">        
<xsl:apply-templates select="attribute"/>
</table>
<xsl:call-template name="totop"/>
</xsl:template>  

<xsl:template match="attribute">  
  <xsl:choose>
    <xsl:when test="position() mod 2">
      <tr bgcolor="#fffffa">
        <td width="10%">
          <xsl:choose>            
          <xsl:when test="@isStatic = 'true'">
            <small><xsl:text>static </xsl:text></small>
          </xsl:when>
          <xsl:otherwise>
            <xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>            
          </xsl:otherwise>
        </xsl:choose>
        </td>
        <td width="90%">
          <xsl:text>@</xsl:text>
          <a href="#{@name}"><xsl:value-of select="@name"/></a>
          <xsl:if test="@isHidden = 'true'">
            <xsl:text> !</xsl:text>
          </xsl:if>
          <xsl:if test="@type">
            <xsl:text> TYPEOF </xsl:text>
            <a>
              <xsl:attribute name="href">
                <xsl:call-template name="urify">
                  <xsl:with-param name="conceptName"><xsl:value-of select="@type"/></xsl:with-param>
                </xsl:call-template>
              </xsl:attribute>
              <xsl:value-of select="@type"/>
            </a>
          </xsl:if>
          <xsl:if test="@label">
           <xsl:text> LABEL </xsl:text>
           <xsl:text disable-output-escaping="yes">&amp;quot;</xsl:text>      
           <xsl:value-of select="@label"/>
           <xsl:text disable-output-escaping="yes">&amp;quot;</xsl:text>      
         </xsl:if>
       </td>
     </tr>
    </xsl:when>
    <xsl:otherwise>
      <tr bgcolor="#ffffff">
        <td width="10%">
          <xsl:choose>            
          <xsl:when test="@isStatic = 'true'">
            <small><xsl:text>static </xsl:text></small>
          </xsl:when>
          <xsl:otherwise>
            <xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>            
          </xsl:otherwise>
        </xsl:choose>
        </td>
        <td width="90%">
          <xsl:text>@</xsl:text>
          <a href="#{@name}"><xsl:value-of select="@name"/></a>
          <xsl:if test="@isHidden = 'true'">
            <xsl:text> !</xsl:text>
          </xsl:if>
          <xsl:if test="@type">
            <xsl:text> TYPEOF </xsl:text>
            <a href="{@type}.html"><xsl:value-of select="@type"/></a>           
          </xsl:if>
          <xsl:if test="@label">
           <xsl:text> LABEL </xsl:text>
           <xsl:text disable-output-escaping="yes">&amp;quot;</xsl:text>      
           <xsl:value-of select="@label"/>
           <xsl:text disable-output-escaping="yes">&amp;quot;</xsl:text>      
         </xsl:if>
       </td>
     </tr>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>  

<xsl:template match="inheritedAttributes">
  <table border="0" width="95%" align="center" cellpadding="1" cellspacing="1" bgcolor="#dddddd">
    <xsl:apply-templates select="concept" mode="inheritedAttributes"/>
  </table>
</xsl:template>

<xsl:template match="concept" mode="inheritedAttributes">
    <tr bgcolor="#fffffa">
      <td>
        <b><xsl:text>Attributes inherited from: </xsl:text><a href="{@docName}"><xsl:value-of select="@name"/></a></b>
        <table width="100%" border="0" bgcolor="#ffffff">
          <tr>
            <td>
              <xsl:apply-templates select="attributes/attribute" mode="theAttributes">
                <xsl:with-param name="baseDoc"><xsl:value-of select="@docName"/></xsl:with-param>
              </xsl:apply-templates>
            </td>
          </tr>
        </table>
      </td>
    </tr>
</xsl:template>


<xsl:template match="attribute" mode="theAttributes">
  <xsl:param name="baseDoc"></xsl:param>
  <a href="{$baseDoc}#{@name}"><xsl:value-of select="@name"/></a>
  <xsl:if test="not(position() = last())">
    <xsl:text>, </xsl:text>
  </xsl:if>
</xsl:template>


<xsl:template match="elementes">    
<h3><a name="ElementList">Element List</a></h3>
<table width="95%" cellspacing="1" cellpadding="3" align="center" border="0" bgcolor="#dddddd">        
<xsl:apply-templates select="element"/>
</table>
<xsl:call-template name="totop"/>
</xsl:template>  


<xsl:template match="element">  
  <xsl:choose>
    <xsl:when test="position() mod 2">
      <tr bgcolor="#faffff">
        <td width="10%">
          <xsl:choose>            
          <xsl:when test="@isStatic = 'true'">
            <small><xsl:text>static </xsl:text></small>
          </xsl:when>
          <xsl:otherwise>
            <xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>            
          </xsl:otherwise>
        </xsl:choose>
        </td>
        <td width="90%">
          <a href="#{@name}"><xsl:value-of select="@name"/></a>
          <xsl:if test="@isMulti = 'true'">
            <xsl:text>*</xsl:text>
          </xsl:if>
          <xsl:if test="@isHidden = 'true'">
            <xsl:text>!</xsl:text>
          </xsl:if>
          <xsl:if test="@type">
            <xsl:text> TYPEOF </xsl:text>
            <a>
              <xsl:attribute name="href">
                <xsl:call-template name="urify">
                  <xsl:with-param name="conceptName"><xsl:value-of select="@type"/></xsl:with-param>
                </xsl:call-template>
              </xsl:attribute>
              <xsl:value-of select="@type"/>
            </a>
          </xsl:if>
          <xsl:if test="@label">
           <xsl:text> LABEL </xsl:text>
           <xsl:text disable-output-escaping="yes">&amp;quot;</xsl:text>      
           <xsl:value-of select="@label"/>
           <xsl:text disable-output-escaping="yes">&amp;quot;</xsl:text>      
         </xsl:if>
       </td>
     </tr>
    </xsl:when>
    <xsl:otherwise>
      <tr bgcolor="#ffffff">
        <td width="10%">
          <xsl:choose>            
          <xsl:when test="@isStatic = 'true'">
            <small><xsl:text>static </xsl:text></small>
          </xsl:when>
          <xsl:otherwise>
            <xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>            
          </xsl:otherwise>
        </xsl:choose>
        </td>
        <td width="90%">
          <a href="#{@name}"><xsl:value-of select="@name"/></a>
          <xsl:if test="@isMulti = 'true'">
            <xsl:text>*</xsl:text>
          </xsl:if>
          <xsl:if test="@isHidden = 'true'">
            <xsl:text>!</xsl:text>
          </xsl:if>
          <xsl:if test="@type">
            <xsl:text> TYPEOF </xsl:text>
            <a>
              <xsl:attribute name="href">
                <xsl:call-template name="urify">
                  <xsl:with-param name="conceptName"><xsl:value-of select="@type"/></xsl:with-param>
                </xsl:call-template>
              </xsl:attribute>
              <xsl:value-of select="@type"/>
            </a>
          </xsl:if>
          <xsl:if test="@label">
           <xsl:text> LABEL </xsl:text>
           <xsl:text disable-output-escaping="yes">&amp;quot;</xsl:text>      
           <xsl:value-of select="@label"/>
           <xsl:text disable-output-escaping="yes">&amp;quot;</xsl:text>      
         </xsl:if>
       </td>
     </tr>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<xsl:template match="inheritedElementes">
  <table border="0" width="95%" align="center" bgcolor="#dddddd" cellpadding="1" cellspacing="1">
    <xsl:apply-templates select="concept" mode="inheritedElementes"/>
  </table>
</xsl:template>

<xsl:template match="concept" mode="inheritedElementes">
    <tr bgcolor="#faffff">
      <td>
        <b><xsl:text>Elementes inherited from: </xsl:text><a href="{@docName}"><xsl:value-of select="@name"/></a></b>
        <table width="100%" border="0" bgcolor="#ffffff">
          <tr>
            <td>
              <xsl:apply-templates select="elementes/element" mode="theElementes">
                <xsl:with-param name="baseDoc"><xsl:value-of select="@docName"/></xsl:with-param>
              </xsl:apply-templates>
            </td>
          </tr>
        </table>
      </td>
    </tr>
</xsl:template>


<xsl:template match="element" mode="theElementes">
  <xsl:param name="baseDoc"></xsl:param>
  <a href="{$baseDoc}#{@name}"><xsl:value-of select="@name"/></a>
  <xsl:if test="not(position() = last())">
    <xsl:text>, </xsl:text>
  </xsl:if>
</xsl:template>


<xsl:template match="constructors">
  <h3><a name="ConstructorList">Constructor List</a></h3>
  <table width="95%" cellspacing="1" cellpadding="3" align="center" border="0" bgcolor="#dddddd">        
    <xsl:apply-templates select="constructor"/>
  </table>  
  <xsl:call-template name="totop"/>
</xsl:template>  


<xsl:template match="constructor">    
  <xsl:choose>
    <xsl:when test="position() mod 2">
      <tr bgcolor="#fffafa">          
      <td>            
         <a><xsl:attribute name="href"><xsl:text>#</xsl:text><xsl:call-template name="computeHref"/></xsl:attribute><xsl:value-of select="@name"/></a>
         <xsl:if test="parameter"><xsl:text> (</xsl:text><xsl:apply-templates select="parameter"/><xsl:text>) </xsl:text>            
         </xsl:if>
       </td>
     </tr>
    </xsl:when>
    <xsl:otherwise>
      <tr bgcolor="#ffffff">          
      <td>
        <a><xsl:attribute name="href"><xsl:text>#</xsl:text><xsl:call-template name="computeHref"/></xsl:attribute><xsl:value-of select="@name"/></a>            
        <xsl:if test="parameter"><xsl:text> (</xsl:text><xsl:apply-templates select="parameter"/><xsl:text>) </xsl:text>            
        </xsl:if>
      </td>        
    </tr>                  
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>  


<!-- CONCEPT OPERATORS                                          -->
<xsl:template match="operators">
  <h3><a name="OperatorList">Operator List</a></h3>
  <table width="95%" cellspacing="1" cellpadding="3" align="center" border="0" bgcolor="#dddddd">        
    <xsl:apply-templates select="operator"/>
  </table>  
  <xsl:call-template name="totop"/>
</xsl:template>  


<!-- CONCEPT OPERATOR                                           -->
<xsl:template match="operator">
  <xsl:choose>
    <xsl:when test="position() mod 2">
      <tr bgcolor="#fafffa">          
      <td width="10%" align="left" valign="top">            
      <a>
        <xsl:attribute name="href">
          <xsl:call-template name="urify">
            <xsl:with-param name="conceptName"><xsl:value-of select="@returns"/></xsl:with-param>
          </xsl:call-template>
        </xsl:attribute>
        <xsl:value-of select="@returns"/>
      </a>      
    </td>          
    <td width="90%">            
    <a><xsl:attribute name="href"><xsl:text>#</xsl:text><xsl:call-template name="computeHref"/></xsl:attribute><xsl:value-of select="@name"/></a>
    <xsl:if test="parameter"><xsl:text> (</xsl:text><xsl:apply-templates select="parameter"/><xsl:text>) </xsl:text>            
    </xsl:if>
  </td>        
   </tr>            
    </xsl:when>
    <xsl:otherwise>
      <tr bgcolor="#ffffff">          
      <td width="10%" align="left" valign="top">            
      <a>
        <xsl:attribute name="href">
          <xsl:call-template name="urify">
            <xsl:with-param name="conceptName"><xsl:value-of select="@returns"/></xsl:with-param>
          </xsl:call-template>
        </xsl:attribute>
        <xsl:value-of select="@returns"/>
      </a>      
    </td>          
    <td width="90%">            
    <a><xsl:attribute name="href"><xsl:text>#</xsl:text><xsl:call-template name="computeHref"/></xsl:attribute><xsl:value-of select="@name"/></a>
    <xsl:if test="parameter"><xsl:text> (</xsl:text><xsl:apply-templates select="parameter"/><xsl:text>) </xsl:text>            
    </xsl:if>
    </td>        
   </tr>                  
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<xsl:template match="methods">  
<h3><a name="MethodList">Method List</a></h3>
  <table width="95%" cellspacing="1" cellpadding="3" align="center" border="0" bgcolor="#dddddd">  
  <xsl:apply-templates select="method"/>
  </table>
  <xsl:call-template name="totop"/>
</xsl:template>


<xsl:template match="method">
  <xsl:choose>
    <xsl:when test="position() mod 2">
      <tr bgcolor="#fafaff">          
      <td width="20%" align="right" valign="top">
        <xsl:if test="@isStatic = 'true'">
          <small><xsl:text>static </xsl:text></small>
        </xsl:if>
      <a>
        <xsl:attribute name="href">
          <xsl:call-template name="urify">
            <xsl:with-param name="conceptName"><xsl:value-of select="@returns"/></xsl:with-param>
          </xsl:call-template>
        </xsl:attribute>
        <xsl:value-of select="@returns"/>
      </a>      
    </td>          
    <td width="80%">            
    <a><xsl:attribute name="href"><xsl:text>#</xsl:text><xsl:call-template name="computeHref"/></xsl:attribute><xsl:value-of select="@name"/></a>
    <xsl:if test="parameter"><xsl:text> (</xsl:text><xsl:apply-templates select="parameter"/><xsl:text>) </xsl:text>            
    </xsl:if>
  </td>        
   </tr>            
    </xsl:when>
    <xsl:otherwise>
      <tr bgcolor="#ffffff">          
      <td width="20%" align="right" valign="top">            
        <xsl:if test="@isStatic = 'true'">
          <small><xsl:text>static </xsl:text></small>
        </xsl:if>
      <a>
        <xsl:attribute name="href">
          <xsl:call-template name="urify">
            <xsl:with-param name="conceptName"><xsl:value-of select="@returns"/></xsl:with-param>
          </xsl:call-template>
        </xsl:attribute>
        <xsl:value-of select="@returns"/>
      </a>      
    </td>          
    <td width="80%">
    <a><xsl:attribute name="href"><xsl:text>#</xsl:text><xsl:call-template name="computeHref"/></xsl:attribute><xsl:value-of select="@name"/></a>            
    <xsl:if test="parameter"><xsl:text> (</xsl:text><xsl:apply-templates select="parameter"/><xsl:text>) </xsl:text>            
    </xsl:if>
  </td>        
   </tr>                  
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<xsl:template match="inheritedMethods">
  <table border="0" width="95%" align="center" bgcolor="#dddddd" cellpadding="1" cellspacing="1">
    <xsl:apply-templates select="concept" mode="inheritedMethods"/>
  </table>
</xsl:template>

<xsl:template match="concept" mode="inheritedMethods">
    <tr bgcolor="#fafaff">
      <td>
        <b><xsl:text>Methods inherited from: </xsl:text><a href="{@docName}"><xsl:value-of select="@name"/></a></b>
        <table width="100%" border="0" bgcolor="#ffffff">
          <tr>
            <td>
              <xsl:apply-templates select="methods/method" mode="theMethods">
                <xsl:with-param name="baseDoc"><xsl:value-of select="@docName"/></xsl:with-param>
              </xsl:apply-templates>
            </td>
          </tr>
        </table>
      </td>
    </tr>
</xsl:template>


<xsl:template match="method" mode="theMethods">
  <xsl:param name="baseDoc"></xsl:param>
  <a>
    <xsl:attribute name="href">
      <xsl:value-of select="$baseDoc"/><xsl:text>#</xsl:text><xsl:call-template name="computeHref"/>
    </xsl:attribute>
    <xsl:attribute name="title">
      <xsl:call-template name="computeHref"/>
    </xsl:attribute>
    <xsl:value-of select="@name"/>
  </a>
  <xsl:if test="not(position() = last())">
    <xsl:text>, </xsl:text>
  </xsl:if>
</xsl:template>


<xsl:template name="AttrInfo">
  <xsl:if test="//attribute">
  <h3><a name="AttributeInfo">Detailed Attribute Info</a></h3>
  <xsl:apply-templates select="//attribute" mode="detailedAttrInfo"/>   
  </xsl:if>
</xsl:template>


<xsl:template match="attribute" mode="detailedAttrInfo">
  <h4><a name="{@name}">  <xsl:text>@</xsl:text><xsl:value-of select="@name"/></a></h4>
  <table width="95%" border="0" bgcolor="#eeeeee" cellpadding="1" cellspacing="1" align="center">
    <tr>
      <td bgcolor="#efefef" align="right" width="15%">Label:</td>
      <td bgcolor="white" width="85%"><xsl:value-of select="@label"/></td>
    </tr>
    <tr>
      <td bgcolor="#efefef" align="right" width="15%">Type:</td>
      <td bgcolor="white" width="85%"><a href="{@type}.html"><xsl:value-of select="@type"/></a></td>
    </tr>
    <tr>
      <td bgcolor="#efefef" align="right" width="15%">Is Static:</td>
      <td bgcolor="white" width="85%"><xsl:value-of select="@isStatic"/></td>
    </tr>
    <tr>
      <td bgcolor="#efefef" align="right" width="15%">Is Hidden:</td>
      <td bgcolor="white" width="85%"><xsl:value-of select="@isHidden"/></td>
    </tr>
    <tr>
      <td bgcolor="#efefef" align="right" width="15%">Show Empty:</td>
      <td bgcolor="white" width="85%"><xsl:value-of select="@showEmpty"/></td>
    </tr>
  </table>
    <p>  
    <xsl:apply-templates select="description"/>
    </p>
  <xsl:call-template name="totop"/>
</xsl:template>


<xsl:template name="ElemInfo">
  <xsl:if test="//element">
  <h3><a name="ElementInfo">Detailed Element Info</a></h3>
  <xsl:apply-templates select="/scriptref/elementes/element" mode="detailedElementInfo"/>    
  </xsl:if>
</xsl:template>


<xsl:template match="element" mode="detailedElementInfo">
  <h4><a name="{@name}"><xsl:value-of select="@name"/></a></h4>
  <table width="95%" border="0" bgcolor="#eeeeee" cellpadding="1" cellspacing="1" align="center">
    <tr>
      <td bgcolor="#efefef" align="right" width="15%">Label:</td>
      <td bgcolor="white" width="85%"><xsl:value-of select="@label"/></td>
    </tr>
    <tr>
      <td bgcolor="#efefef" align="right" width="15%">Type:</td>
      <td bgcolor="white" width="85%">
      <a>
        <xsl:attribute name="href">
          <xsl:call-template name="urify">
            <xsl:with-param name="conceptName"><xsl:value-of select="@type"/></xsl:with-param>
          </xsl:call-template>
        </xsl:attribute>
        <xsl:value-of select="@type"/>
      </a>      
    </td>
    </tr>
    <tr>
      <td bgcolor="#efefef" align="right" width="15%">Is Static:</td>
      <td bgcolor="white" width="85%"><xsl:value-of select="@isStatic"/></td>
    </tr>
    <tr>
      <td bgcolor="#efefef" align="right" width="15%">Is Hidden:</td>
      <td bgcolor="white" width="85%"><xsl:value-of select="@isHidden"/></td>
    </tr>
    <tr>
      <td bgcolor="#efefef" align="right" width="15%">Is Multi:</td>
      <td bgcolor="white" width="85%"><xsl:value-of select="@isMulti"/></td>
    </tr>
    <tr>
      <td bgcolor="#efefef" align="right" width="15%">Show Empty:</td>
      <td bgcolor="white" width="85%"><xsl:value-of select="@showEmpty"/></td>
    </tr>
  </table>
  <p>
    <xsl:apply-templates select="description"/>
  </p>
  <xsl:call-template name="totop"/>
</xsl:template>


<xsl:template name="ConstructorInfo">
  <xsl:if test="//constructor">
  <h3><a name="ConstructorInfo">Detailed Constructor Info</a></h3>
  <xsl:apply-templates select="//constructor" mode="detailedConstructorInfo"/>    
  </xsl:if>
</xsl:template>


<xsl:template match="constructor" mode="detailedConstructorInfo">
  <table width="98%" align="center" border="0" bgcolor="#dddddd" cellspacing="1" cellpadding="1">
    <tr bgcolor="#fffafa">
      <td>
        <b><a><xsl:attribute name="name"><xsl:call-template name="computeHref"/></xsl:attribute><xsl:value-of select="@name"/></a></b>
        <xsl:if test="parameter"><xsl:text> (</xsl:text><xsl:apply-templates select="parameter"/><xsl:text>)</xsl:text>
        </xsl:if>
      </td>
    </tr>
  </table>
  <xsl:call-template name="ParameterInfo"/>
  <xsl:call-template name="ExceptionInfo"/>
  <p>
    <xsl:apply-templates select="description"/>
  </p>
  <xsl:call-template name="totop"/>
</xsl:template>


<xsl:template name="MethodInfo">
  <xsl:if test="//method">
  <h3><a name="MethodInfo">Detailed Method Info</a></h3>
  <xsl:apply-templates select="/scriptref/methods/method" mode="detailedMethodInfo"/>    
  </xsl:if>
</xsl:template>


<xsl:template match="method" mode="detailedMethodInfo">
  <table width="98%" align="center" border="0" bgcolor="#dddddd" cellspacing="1" cellpadding="1">
    <tr bgcolor="#fafaff">
      <td>        
        <xsl:if test="@isStatic = 'true'">
            <small><xsl:text>static </xsl:text></small>
        </xsl:if>
        <b><a><xsl:attribute name="name"><xsl:call-template name="computeHref"/></xsl:attribute><xsl:value-of select="@name"/></a></b>
        <xsl:if test="parameter"><xsl:text> (</xsl:text><xsl:apply-templates select="parameter"/><xsl:text>)</xsl:text>
        </xsl:if>
      </td>
    </tr>
  </table>
  
  <xsl:call-template name="ParameterInfo"/>
  <xsl:if test="@returns">
      <table border="0" width="95%" align="center" cellspacing="0" cellpadding="0">
      <tr>
        <td><u>Returns:</u><xsl:text>  </xsl:text> 
        <a>
        <xsl:attribute name="href">
          <xsl:call-template name="urify">
            <xsl:with-param name="conceptName"><xsl:value-of select="@returns"/></xsl:with-param>
          </xsl:call-template>
        </xsl:attribute>
        <xsl:value-of select="@returns"/>
      </a>      
    </td>
      </tr>
      </table>
  </xsl:if>     
  <xsl:call-template name="ExceptionInfo"/>
  <p>
    <xsl:apply-templates select="description"/>
  </p>
  <xsl:call-template name="totop"/>
</xsl:template>


<xsl:template name="OperatorInfo">
  <xsl:if test="//operator">
  <h3><a name="OperatorInfo">Detailed Operator Info</a></h3>
  <xsl:apply-templates select="//operator" mode="detailedOperatorInfo"/>    
  </xsl:if>
</xsl:template>


<xsl:template match="operator" mode="detailedOperatorInfo">
  <table width="98%" align="center" border="0" bgcolor="#dddddd" cellspacing="1" cellpadding="1">
    <tr bgcolor="#fafffa">
      <td>
        <b><a><xsl:attribute name="name"><xsl:call-template name="computeHref"/></xsl:attribute><xsl:value-of select="@name"/></a></b>
        <xsl:if test="parameter"><xsl:text> (</xsl:text><xsl:apply-templates select="parameter"/><xsl:text>)</xsl:text>
        </xsl:if>
      </td>
    </tr>
  </table>
  <xsl:call-template name="ParameterInfo"/>
  <xsl:call-template name="ExceptionInfo"/>
  <p>
    <xsl:apply-templates select="description"/>
  </p>
  <xsl:call-template name="totop"/>
</xsl:template>


<xsl:template name="ParameterInfo">
  <xsl:if test="parameter">
    <table border="0" width="95%" align="center" cellspacing="0" cellpadding="0">
      <tr><td><u>Parameters:</u></td></tr>
      <tr>
        <td>
          <table width="90%" border="0" align="center">
            <xsl:apply-templates select="parameter" mode="detailedParameterInfo"/>
          </table>
        </td>
      </tr>
    </table>
  </xsl:if>
</xsl:template>


<xsl:template match="parameter" mode="detailedParameterInfo">
  <tr>
    <td align="right" width="15%" valign="top"><tt><xsl:value-of select="@name"/></tt><xsl:text> :</xsl:text></td>
    <td width="85%" valign="top"><xsl:apply-templates select="description"/></td>
  </tr>
</xsl:template>



<xsl:template name="ExceptionInfo">
  <xsl:if test="exception">
    <table border="0" width="95%" align="center" cellspacing="0" cellpadding="0">
      <tr><td><u>Exceptions:</u></td></tr>
      <tr>
        <table width="90%" border="0" align="center">
          <xsl:apply-templates select="exception" mode="detailedExceptionInfo"/>
        </table>
      </tr>
    </table>
  </xsl:if>
</xsl:template>


<xsl:template match="exception" mode="detailedExceptionInfo">
  <tr>
    <td align="right" width="15%" valign="top">
      <tt><xsl:value-of select="@name"/></tt>
      <xsl:if test="@type"><xsl:text> :</xsl:text>
        <br/>
        <small><xsl:text>(</xsl:text><i><xsl:value-of select="@type"/></i><xsl:text>)</xsl:text></small>
      </xsl:if>
    </td>
    <td width="85%" valign="top"><xsl:apply-templates select="description"/></td>
  </tr>
</xsl:template>



<xsl:template match="description">    
<xsl:apply-templates/>  
</xsl:template>      


<xsl:template match="p">    
<p><xsl:apply-templates/></p>  
</xsl:template>  


<xsl:template match="i">    
<i><xsl:apply-templates/></i>  
</xsl:template>  


<xsl:template match="tt">    
<tt><xsl:apply-templates/></tt>  
</xsl:template>  


<xsl:template match="em">    
<em><xsl:apply-templates/></em>  
</xsl:template>  


<xsl:template match="b">    
<b><xsl:apply-templates/></b>  
</xsl:template>  


<xsl:template match="pre">    
<pre>
<xsl:apply-templates/>
</pre>  
</xsl:template>  


<xsl:template match="br">    
    <br/>
</xsl:template>  


<xsl:template match="li">    
    <li><xsl:apply-templates/></li>    
</xsl:template>  


<xsl:template match="ul">    
    <ul>
        <xsl:apply-templates/>
    </ul>    
</xsl:template>  

<xsl:template match="a">    
    <a href="{@href}" title="{@title}"><xsl:value-of select="."/></a>
</xsl:template>  


<xsl:template match="ol">    
    <ol>
        <xsl:apply-templates/>
    </ol>    
</xsl:template>  


<xsl:template match="code">
    <pre>
        <xsl:apply-templates/>
    </pre>
</xsl:template>

<xsl:template match="parameter">    
  <a>
    <xsl:attribute name="href">
      <xsl:call-template name="urify">
        <xsl:with-param name="conceptName"><xsl:value-of select="@type"/></xsl:with-param>
      </xsl:call-template>
    </xsl:attribute>
    <xsl:value-of select="@type"/>
  </a>      
  <xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>       
  <tt><xsl:value-of select="@name"/></tt>
  <xsl:if test="not(position() = last())"><xsl:text>, </xsl:text></xsl:if>  
</xsl:template>


<xsl:template name="computeHref">
  <xsl:value-of select="@name"/>
  <xsl:text>:</xsl:text>
  <xsl:apply-templates select="parameter" mode="computeHrefParam"/>
</xsl:template>


<xsl:template match="parameter" mode="computeHrefParam">
  <xsl:if test="position() != 1 ">
    <xsl:text>,</xsl:text>
  </xsl:if>
  <xsl:value-of select="@type"/>
</xsl:template>



<xsl:template name="urify">
  <xsl:param name="conceptName"></xsl:param>
  <xsl:choose>
    <xsl:when test="contains($conceptName,':')">
      <xsl:call-template name="urify">
        <xsl:with-param name="conceptName"><xsl:value-of select="concat(substring-before($conceptName,':'), '_', substring-after($conceptName, ':'))"/></xsl:with-param>
      </xsl:call-template>
    </xsl:when>    
    <xsl:otherwise><xsl:value-of select="concat($conceptName, '.html')"/></xsl:otherwise>
  </xsl:choose>
</xsl:template>


<xsl:template name="totop">
  <div align="right">
    <a href="#top" title="to top">
      <img src="../images/totop.gif" alt="top" border="0" />
    </a>  
  </div>
</xsl:template>


</xsl:stylesheet>
