<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

  <xsl:output encoding="iso-8859-1"  
    doctype-public='-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd'  
    method="html"/>  

  <xsl:template match="category">
    <html>
      <head>
        <title><xsl:value-of select="@name"/> <xsl:text>Category</xsl:text></title>
        <link href="../res/mref.css" rel="StyleSheet" TITLE="Default" MEDIA="screen"/>
      </head>      
      <body bgcolor="#FFFFFF">
        <table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="#eceef9">
          <tr>
            <td bgcolor="#eceef9" align="right">
              <a href="../reference/index.html">mn8 Language Reference</a>
              <xsl:text disable-output-escaping="yes">&amp;nbsp;|&amp;nbsp;</xsl:text>
              <a href="../index_all.html">Index</a>
              <xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;</xsl:text>
            </td>
          </tr>
          <tr>
            <td bgcolor="#eceef9"><h2><a name="top">  <xsl:value-of select="@name"/></a></h2>
          </td>
        </tr>
        <tr>
          <td><img src="../images/bottom.gif" width="100%" height="10" alt=""/></td>
        </tr>
      </table>
      
      <xsl:if test="subcategory">
        <h4>Subcategories</h4>
        <table border="0" cellpadding="1" cellspacing="1" bgcolor="#eeeeee" width="95%" align="center">
          <xsl:apply-templates select="subcategory"/>      
        </table>
      </xsl:if>
    
      <xsl:if test="concept">
        <h4>Concepts</h4>
        <table border="0" cellpadding="1" cellspacing="1" bgcolor="#eeeeee" width="95%" align="center">
          <xsl:apply-templates select="concept"/>              
        </table>
      </xsl:if>

      </body>
    </html>
  </xsl:template>


  <xsl:template name="subcategory" match="subcategory">
  <xsl:choose>
    <xsl:when test="position() mod 2">
      <tr bgcolor="#fffefe">
        <td>
          <a href="{@docName}" target="infoFrame"><xsl:value-of select="@name"/></a>
       </td>
     </tr>
    </xsl:when>
    <xsl:otherwise>
      <tr bgcolor="#ffffff">
        <td>
          <a href="{@docName}" target="infoFrame"><xsl:value-of select="@name"/></a>
       </td>
     </tr>
   </xsl:otherwise>
  </xsl:choose>
  </xsl:template>


  <xsl:template name="concept" match="concept">
  <xsl:choose>
    <xsl:when test="position() mod 2">
      <tr bgcolor="#fefeff">
        <td>
          <b><a href="../concepts/{@docName}" target="infoFrame"><xsl:value-of select="@name"/></a></b>
          <table cellspacing="1" cellpadding="1" width="90%" align="right">
            <tr>
              <td>
                <xsl:apply-templates/>
              </td>
            </tr>
          </table>
       </td>
     </tr>
    </xsl:when>
    <xsl:otherwise>
      <tr bgcolor="#ffffff">
        <td>
          <b><a href="../concepts/{@docName}" target="infoFrame"><xsl:value-of select="@name"/></a></b>
          <table cellspacing="1" cellpadding="1" width="90%" align="right">
            <tr>
              <td>
                <xsl:apply-templates/>
              </td>
            </tr>
          </table>
       </td>
     </tr>
   </xsl:otherwise>
  </xsl:choose>
  </xsl:template>


  <xsl:template name="info" match="info">
    <xsl:apply-templates/>
  </xsl:template>


  <xsl:template match="p">    
  <p>
    <xsl:apply-templates/>
  </p>  
  </xsl:template>  


<xsl:template match="i">    
<i><xsl:apply-templates/></i>  
</xsl:template>  


<xsl:template match="tt">    
<tt><xsl:apply-templates/></tt>  
</xsl:template>  


<xsl:template match="em">    
<em><xsl:apply-templates/></em>  
</xsl:template>  


<xsl:template match="b">    
<b><xsl:apply-templates/></b>  
</xsl:template>  


<xsl:template match="pre">    
<pre>
<xsl:apply-templates/>
</pre>  
</xsl:template>  

</xsl:stylesheet>


