<?xml version="1.0" encoding="utf-8"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

  <xsl:output encoding="iso-8859-1"  
    doctype-public='-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd'  
    method="html"/>  

  <xsl:template match="/">
    <html>
      <head>
        <title><xsl:value-of select="@name"/> <xsl:text>Category</xsl:text></title>
        <link href="../res/mref.css" rel="StyleSheet" TITLE="Default" MEDIA="screen"/>
      </head>      
  
      <body bgcolor="#FFFFFF">
        <xsl:apply-templates/>
      </body>
    </html>
  </xsl:template>


  <xsl:template name="category" match="category">
    <h3><xsl:value-of select="@name"/></h3> 

    <xsl:if test="subcategory">
      <h4>Categories</h4>
      <table border="0" cellpadding="1" cellspacing="1" bgcolor="#eeeeee" width="100%">
        <xsl:apply-templates select="subcategory"/>      
      </table>
    </xsl:if>
    
    <xsl:if test="concept">
      <h4>Concepts</h4>
      <table border="0" cellpadding="1" cellspacing="1" bgcolor="#eeeeee" width="100%">
        <xsl:apply-templates select="concept"/>              
      </table>
    </xsl:if>
  </xsl:template>


  <xsl:template name="subcategory" match="subcategory">
  <xsl:choose>
    <xsl:when test="position() mod 2">
      <tr bgcolor="#fffefe">
        <td>
          <a href="{@docName}" target="infoFrame"><xsl:value-of select="@name"/></a>
       </td>
     </tr>
    </xsl:when>
    <xsl:otherwise>
      <tr bgcolor="#ffffff">
        <td>
          <a href="{@docName}" target="infoFrame"><xsl:value-of select="@name"/></a>
       </td>
     </tr>
   </xsl:otherwise>
  </xsl:choose>
  </xsl:template>


  <xsl:template name="concept" match="concept">
  <xsl:choose>
    <xsl:when test="position() mod 2">
      <tr bgcolor="#fefeff">
        <td>
          <a href="../concepts/{@docName}" target="infoFrame"><xsl:value-of select="@name"/></a>
       </td>
     </tr>
    </xsl:when>
    <xsl:otherwise>
      <tr bgcolor="#ffffff">
        <td>
          <a href="../concepts/{@docName}" target="infoFrame"><xsl:value-of select="@name"/></a>
       </td>
     </tr>
   </xsl:otherwise>
  </xsl:choose>
  </xsl:template>

</xsl:stylesheet>


