<?xml version="1.0" encoding="utf-8"?>

<xsl:stylesheet   
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"  
  version="1.0">

<xsl:output encoding="iso-8859-1"  
  doctype-public='-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd'  
  method="html"/>  


<xsl:template match="/index">    
<html>
  <head>
    <title><xsl:value-of select="@title"/></title>
    <link href="../res/mref.css" rel="StyleSheet" TITLE="Default" MEDIA="screen"/>
  </head>      
  <body bgcolor="#FFFFFF">        
  <table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="#eceef9">
    <tr>
      <td bgcolor="#eceef9" align="right">
        <a href="../reference/index.html">mn8 Language Reference</a>
        <xsl:text disable-output-escaping="yes">&amp;nbsp;|&amp;nbsp;</xsl:text>
        <a href="../index_all.html">Index</a>
        <xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;</xsl:text>
      </td>
    </tr>
    <tr>
      <td bgcolor="#eceef9"><h2><a name="top">  <xsl:value-of select="@title"/></a></h2></td>
    </tr>
    <tr>
      <td bgcolor="#eceef9"><br/></td>
    </tr>
    <tr>
      <td><img src="../images/bottom.gif" width="100%" height="10" alt=""/></td>
    </tr>
  </table>
  <table border="0" width="98%" align="center">
    <tr>
      <td align="left">
        <xsl:apply-templates/>
      </td>
    </tr>
  </table>
</body>    
</html>  
</xsl:template>  



<xsl:template match="/ruleList">    
<html>
  <head>
    <title><xsl:value-of select="@title"/></title>
    <link href="../res/mref.css" rel="StyleSheet" TITLE="Default" MEDIA="screen"/>
  </head>      
  <body bgcolor="#FFFFFF">        
  <table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="#eceef9">
    <tr>
      <td bgcolor="#eceef9" align="right">
        <a href="../reference/index.html">mn8 Language Reference</a>
        <xsl:text disable-output-escaping="yes">&amp;nbsp;|&amp;nbsp;</xsl:text>
        <a href="../index_all.html">Index</a>
        <xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;</xsl:text>
      </td>
    </tr>
    <tr>
      <td bgcolor="#eceef9"><h2><a name="top">  <xsl:value-of select="@title"/></a></h2></td>
    </tr>
    <tr>
      <td bgcolor="#eceef9"><br/></td>
    </tr>
    <tr>
      <td><img src="../images/bottom.gif" width="100%" height="10" alt=""/></td>
    </tr>
  </table>
  <table border="0" width="98%" align="center">
    <tr>
      <td align="left">
        <b>Contents</b><br/>
        <ol>
          <xsl:for-each select="//rule">
            <xsl:call-template name="keyToc"/> 
          </xsl:for-each>
        </ol>
        <xsl:apply-templates/>
      </td>
    </tr>
  </table>
</body>    
</html>  
</xsl:template>  


<xsl:template match="/keywordsList">    
<html>
  <head>
    <title><xsl:value-of select="@title"/></title>
    <link href="../res/mref.css" rel="StyleSheet" TITLE="Default" MEDIA="screen"/>
  </head>      
  <body bgcolor="#FFFFFF">        
  <table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="#eceef9">
    <tr>
      <td bgcolor="#eceef9" align="right">
        <a href="../reference/index.html">mn8 Language Reference</a>
        <xsl:text disable-output-escaping="yes">&amp;nbsp;|&amp;nbsp;</xsl:text>
        <a href="../index_all.html">Index</a>
        <xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;</xsl:text>
      </td>
    </tr>
    <tr>
      <td bgcolor="#eceef9"><h2><a name="top">  <xsl:value-of select="@title"/></a></h2></td>
    </tr>
    <tr>
      <td bgcolor="#eceef9"><br/></td>
    </tr>
    <tr>
      <td><img src="../images/bottom.gif" width="100%" height="10" alt=""/></td>
    </tr>
  </table>
  <table border="0" width="98%" align="center">
    <tr>
      <td align="left">
        <b>Contents</b><br/>
        <ul>
          <xsl:for-each select="//keyword">
            <xsl:call-template name="keyToc"/> 
          </xsl:for-each>
        </ul>
        <xsl:apply-templates/>
      </td>
    </tr>
  </table>
</body>    
</html>  
</xsl:template>  


<xsl:template match="keyword">
  <h3><a name="{@name}"><xsl:value-of select="@name"/></a></h3>
  <table border="0" width="98%" align="center">
    <tr>
      <td align="left">
        <xsl:apply-templates select="syntax"/>
        <xsl:apply-templates select="description"/>
        <xsl:apply-templates select="usage"/>
      </td>
    </tr>
  </table>
</xsl:template>      



<xsl:template match="rule">
  <h3><a name="{@name}"><xsl:value-of select="@name"/></a></h3>
  <table border="0" width="98%" align="center">
    <tr>
      <td align="left">
        <xsl:apply-templates/>  
        <xsl:call-template name="totop"/>
      </td>
    </tr>
  </table>
</xsl:template>      


<xsl:template match="rule" mode="toc">
  <li><a href="{../@docName}#{@name}"><xsl:value-of select="@name"/></a></li>
</xsl:template>      


<xsl:template match="keyword" mode="toc">
  <li><a href="{../@docName}#{@name}"><xsl:value-of select="@name"/></a></li>
</xsl:template>      


<xsl:template match="chapter">
  <xsl:if test="contains(@docName,'key')">
  <h3><a href="{@docName}"><xsl:value-of select="@title"/></a></h3>
  <table border="0" width="98%" align="center">
    <tr>
      <td align="left">
        <ul>
        <xsl:apply-templates mode="toc"/>  
        </ul>
        <xsl:call-template name="totop"/>
      </td>
    </tr>
  </table>    
  </xsl:if>
</xsl:template>      


<xsl:template match="syntax">
  <h4><a name="{../@name}_Syntax">Syntax</a></h4>
  <table border="0" width="98%" align="center">
    <tr>
      <td align="left">
        <xsl:apply-templates/>  
        <xsl:call-template name="totop"/>
      </td>
    </tr>
  </table>
</xsl:template>      


<xsl:template match="subdeflnk">
  <b><u><xsl:value-of select="."/></u></b>
</xsl:template>      


<xsl:template match="subdef">
  <table align="center" cellpadding="1" cellspacing="1" border="0" bgcolor="#eeeeee" width="95%">
    <xsl:if test="@title">
    <tr bgcolor="#ffffff">
      <td align="center">
        <font color="#777777"><b><u><xsl:value-of select="@title"/></u></b></font>
      </td>
    </tr>      
    </xsl:if>
    <tr bgcolor="#fdfdfd">
      <td align="left">
        <xsl:apply-templates/>  
      </td>
    </tr>
  </table>
  <br/>
  <br/>
</xsl:template>      


<xsl:template match="usage">
  <h4><a name="{../@name}_Usage">Usage</a></h4>
  <table border="0" width="98%" align="center">
    <tr>
      <td align="left">
        <xsl:apply-templates/>  
        <xsl:call-template name="totop"/>
      </td>
    </tr>
  </table>
</xsl:template>      


<xsl:template match="description">    
  <h4><a name="{../@name}_Description">Description</a></h4>
  <table border="0" width="98%" align="center">
    <tr>
      <td align="left">
        <xsl:apply-templates/>  
      </td>
    </tr>
  </table>
</xsl:template>      

<xsl:template match="req">
  <b><xsl:apply-templates/></b>
</xsl:template>

<xsl:template match="key">
  <b><xsl:apply-templates/></b>
</xsl:template>

<xsl:template match="opt">
  <img src="../images/optl.gif" alt="("/><xsl:apply-templates/><img src="../images/optr.gif" alt=")?"/>
</xsl:template>

<xsl:template match="zm">
  <img src="../images/zml.gif" alt="("/><xsl:apply-templates/><img src="../images/zmr.gif" alt=")*"/>
</xsl:template>


<xsl:template match="om">
  <img src="../images/oml.gif" alt="("/><xsl:apply-templates/><img src="../images/omr.gif" alt=")+"/>
</xsl:template>


<xsl:template match="or">
  <img src="../images/orl.gif" alt="("/>
  <xsl:for-each select="oritm">
    <xsl:apply-templates/>
    <xsl:if test="not(position() = last())">
      <img src="../images/orm.gif" alt="|"/>
    </xsl:if>
  </xsl:for-each>
  <img src="../images/orr.gif" alt=")"/>
</xsl:template>

<xsl:template match="expr">
  <u><xsl:value-of select="."/></u>
</xsl:template>


<xsl:template match="p">    
<p><xsl:apply-templates/></p>  
</xsl:template>  


<xsl:template match="dl">    
<dl>
  <xsl:apply-templates/>
</dl>  
</xsl:template>  

<xsl:template match="dd">    
<dd>
  <xsl:apply-templates/>
  <br/>
  <br/>
</dd>  
</xsl:template>  


<xsl:template match="dt">    
<dt><font color="#777777"><b><u><xsl:apply-templates/></u></b></font></dt>  
</xsl:template>  


<xsl:template match="i">    
<i><xsl:apply-templates/></i>  
</xsl:template>  


<xsl:template match="tt">    
<tt><xsl:apply-templates/></tt>  
</xsl:template>  


<xsl:template match="em">    
<em><xsl:apply-templates/></em>  
</xsl:template>  


<xsl:template match="b">    
<b><xsl:apply-templates/></b>  
</xsl:template>  


<xsl:template match="pre">    
<pre>
<xsl:value-of select="."/>
</pre>  
</xsl:template>  


<xsl:template match="br">    
    <br/>
</xsl:template>  


<xsl:template match="li">    
    <li><xsl:apply-templates/></li>    
</xsl:template>  


<xsl:template match="ul">    
    <ul>
        <xsl:apply-templates/>
    </ul>    
</xsl:template>  


<xsl:template match="ol">    
    <ol>
        <xsl:apply-templates/>
    </ol>    
</xsl:template>  


<xsl:template match="code">
    <pre>
      <xsl:apply-templates />
    </pre>
</xsl:template>


<xsl:template match="tab">
  <xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;</xsl:text>
</xsl:template>



<xsl:template name="keyToc">
  <li><a href="#{@name}"><xsl:value-of select="@name"/></a>
  <small>
  <xsl:text>         (</xsl:text>
  <a href="#{@name}_Syntax" title="{@name} Syntax"> <xsl:text>S</xsl:text></a><xsl:text>, </xsl:text>
  <a href="#{@name}_Description" title="{@name} Description"> <xsl:text>D</xsl:text></a><xsl:text>, </xsl:text>
  <a href="#{@name}_Usage" title="{@name} Usage"> <xsl:text>U</xsl:text></a><xsl:text>)</xsl:text>
  </small>
  </li>
</xsl:template>


<xsl:template name="totop">
  <div align="right">
    <a href="#top" title="to top">
      <img src="../images/totop.gif" alt="top" border="0" />
    </a>  
  </div>
</xsl:template>


</xsl:stylesheet>
